import java.io.File
import java.net.URL
import java.nio.file.Files
import java.nio.file.StandardCopyOption

fun main() {
    val folder = File(System.getProperty("user.home") + "/Desktop/uni/")

    folder.mkdir()

    // TODO: Set ur credentials here
    Browser.login("USERNAME", "PASSWORD")
    val courses = Browser.getCourses()

    courses.forEach { course->
        val courseFolder = File(folder, course.name)
        val watchedFolder = File(courseFolder, "Gesehen/")

        courseFolder.mkdir()
        watchedFolder.mkdir()

        println(course.name)

        if(!course.name.startsWith("Studien")) {
            Browser.checkCourseForVids(course)?.let { c ->
                //sleep(10000)

                Browser.getVideoLinks(c).forEach { videoLink ->
                    println(videoLink.name)

                    val file = File(courseFolder, videoLink.name + ".mp4")
                    val watchedFile = File(watchedFolder, videoLink.name + ".mp4")

                    if(!file.exists() && !watchedFile.exists()) {
                        val video = Browser.getVideoLink(videoLink)

                        println(courseFolder.name + ";" + video.name + ";" + video.link)

                        // Create File
                        file.createNewFile()

                        // Then write to it
                        val inStream = URL(video.link).openStream()
                        Files.copy(inStream, file.toPath(), StandardCopyOption.REPLACE_EXISTING)
                    }
                }
            }
        }
    }
}

